<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Front End</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-responsive/css/responsive.bootstrap4.min.css">
  <link rel="stylesheet" href="plugins/datatables-buttons/css/buttons.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>
<body class="hold-transition sidebar-mini">
<div class="wrapper">
  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Front End</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">haiongngoai</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-table"></i>
              <p>
                Quản trị
                <i class="fas fa-angle-left right"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="index.voucher.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.menu.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Menus</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.drink.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Drinks</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.countryregion.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Country/Region</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="index.userorder.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>User/Order</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-12 text-center">
            <h1>Quản trị Country/Region</h1>
          </div>
        </div>
      </div><!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
        <div class="row">
          <div class="col-12">
            <div class="card">
              <div class="card-body">
                <div class="container">
                  <div class="jumbotron container">
                    <div class="row form-group">
                      <div class="col-sm-2 text-right">
                        <label>Country Name</label>
                      </div>
                      <div class="col-sm-4">
                        <input id="inp-country-name" type="text" class="form-control">
                      </div>
                      <div class="col-sm-2 text-right">
                        <label for="region">Country Code</label>
                      </div>
                      <div class="col-sm-4">
                        <input id="inp-country-code" type="text" class="form-control">
                      </div>
                    </div>
                    <div class="col-sm-12 text-right">
                      <button id="btn-create-country" class="btn btn-info">Add country</button>
                      <button id="btn-update-country" class="btn btn-success my-3">Update country</button>
                      <button id="btn-delete-country" class="btn btn-danger">Delete country</button>
                    </div>
                    <hr>
                    <div class="row form-group">
                      <div class="col-sm-2 text-right">
                        <label>Region Name</label>
                      </div>
                      <div class="col-sm-4">
                        <input id="inp-region-name" type="text" class="form-control">
                      </div>
                      <div class="col-sm-2 text-right">
                        <label for="region">Region Code</label>
                      </div>
                      <div class="col-sm-4">
                        <input id="inp-region-code" type="text" class="form-control">
                      </div>
                    </div>
                    <div class="col-sm-12 text-right">
                      <button id="btn-create-region" class="btn btn-info">Add region</button>
                      <button id="btn-update-region" class="btn btn-success my-3">Update region</button>
                      <button id="btn-delete-region" class="btn btn-danger">Delete region</button>
                    </div>
                  </div>
                </div>
                <h3 class="text-center">Country Table</h3>
                <table class="table table-bordered table-striped table-hover text-center" id="country-table">
                  <thead>
                    <tr>
                      <th>STT</th>
                      <th>Country Code</th>
                      <th>Country Name</th>
                    </tr>
                    <tbody>

                    </tbody>
                </table>
                <hr class="border">
                <h3 class="text-center">Region Table</h3>
                <table class="table table-bordered table-striped table-hover text-center" id="region-table">
                  <thead>
                    <tr>
                      <th>STT</th>
                      <th>Region Code</th>
                      <th>Region Name</th>
                    </tr>
                    <tbody>

                    </tbody>
                </table>
              </div>
            </div>
            <!-- /.card -->
          </div>
          <!-- /.col -->
        </div>
        <!-- /.row -->
      </div>
      <!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
</div>
<!-- ./wrapper -->

<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<!-- DataTables  & Plugins -->
<script src="plugins/datatables/jquery.dataTables.min.js"></script>
<script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
<script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
<script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
<script src="plugins/datatables-buttons/js/dataTables.buttons.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.bootstrap4.min.js"></script>
<script src="plugins/jszip/jszip.min.js"></script>
<script src="plugins/pdfmake/pdfmake.min.js"></script>
<script src="plugins/pdfmake/vfs_fonts.js"></script>
<script src="plugins/datatables-buttons/js/buttons.html5.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.print.min.js"></script>
<script src="plugins/datatables-buttons/js/buttons.colVis.min.js"></script>
<!-- AdminLTE App -->
<script src="dist/js/adminlte.min.js"></script>
</body>
<script>
  $(document).ready(function(){
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    //định nghĩa table country
    const gCOL_COUNTRY_ID = 0;
    const gCOL_COUNTRY_CODE = 1;
    const gCOL_COUNTRY_NAME = 2;
    var STT1 = 1;
    var gCountryId = 0;
    const g_COLS = ["id", "countryCode", "countryName"];
    var vTableCountry = $("#country-table").DataTable({
        columns: [
            {data: g_COLS[gCOL_COUNTRY_ID]},
            {data: g_COLS[gCOL_COUNTRY_CODE]},
            {data: g_COLS[gCOL_COUNTRY_NAME]},
        ],
        columnDefs: [
            {
              targets: gCOL_COUNTRY_ID,
              render: function (){
                return STT1++;
              }
            }
        ],
        searching: false,
    });
    //định nghĩa table region
    const gCOL_REGION_ID = 0;
    const gCOL_REGION_CODE = 1;
    const gCOL_REGION_NAME = 2;
    var STT2 = 1;
    var gRegionId = 0;
    const g_COL = ["id", "regionCode", "regionName"];
    var vTableRegion = $("#region-table").DataTable({
        columns: [
            {data: g_COL[gCOL_REGION_ID]},
            {data: g_COL[gCOL_REGION_CODE]},
            {data: g_COL[gCOL_REGION_NAME]},
        ],
        columnDefs: [
            {
              targets: gCOL_REGION_ID,
              render: function (){
                return STT2++;
              }
            }
        ],
        searching: false,
    });
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    onPageLoading();
    //Gán event handler khi click vào hàng bất kỳ
    $("#country-table").on("click", "td", function() {
      onCountryTableRowClick(this);
		});
    //Gán event handler khi click vào hàng bất kỳ
    $("#region-table").on("click", "td", function() {
      onRegionTableRowClick(this);
		});
    // gán sự kiện cho nút add country
    $("#btn-create-country").on("click", function() {
        onBtnCreateCountryClick();
    });
    // gán sự kiện cho nút add region
    $("#btn-create-region").on("click", function() {
        onBtnCreateRegionClick();
    });
    // gán sự kiện cho nút update country
    $("#btn-update-country").on("click", function() {
      onBtnUpdateCountryClick();
    });
    // gán sự kiện cho nút update region
    $("#btn-update-region").on("click", function() {
      onBtnUpdateRegionClick();
    });
    // gán sự kiện cho nút delete country
    $("#btn-delete-country").on("click", function() {
      onBtnDeleteCountryClick();
    });
    // gán sự kiện cho nút delete region
    $("#btn-delete-region").on("click", function() {
      onBtnDeleteRegionClick();
    });
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm load trang
    function onPageLoading() {
      "use strict";
      callApiGetAllCountry();
      callApiGetAllRegion();
    }

    //Hàm gọi APi lấy ra toàn bộ country
    function callApiGetAllCountry(){
      "use strict";
      $.ajax({
        url: "http://localhost:8080/country/all",
        type: "GET",
        dataType: "json",
        success: function(res){
            console.log(res);
            vTableCountry.clear();
            vTableCountry.rows.add(res);
            vTableCountry.draw();
        },
        error: function(err){
            console.log(err.responseText);
        }
      })
    }
    //Hàm gọi APi lấy ra toàn bộ region
    function callApiGetAllRegion(){
      "use strict";
      $.ajax({
        url: "http://localhost:8080/region/all",
        type: "GET",
        dataType: "json",
        success: function(res){
            console.log(res);
            vTableRegion.clear();
            vTableRegion.rows.add(res);
            vTableRegion.draw();
        },
        error: function(err){
            console.log(err.responseText);
        }
      })
    }
    //Hàm thực thi khi click vào hàng bất kỳ
    function onCountryTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = vTableCountry.row(vClickedRow).data();
			gCountryId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gCountryId);
			callAjaxApiGetCountryById(gCountryId);
		}
    //Hàm thực thi khi click vào hàng bất kỳ
    function onRegionTableRowClick(paramTableCell) {
			var vClickedRow = $(paramTableCell).parents("tr");
			var vRowData = vTableRegion.row(vClickedRow).data();
			gRegionId = vRowData.id;			
			console.log("Đã click vào row có id là: " + gRegionId);
			callAjaxApiGetRegionById(gRegionId);
		}
    //Hàm thực thi khi nhấn nút Add country
    function onBtnCreateCountryClick(){
      "uses strict";
      var vObj = {
				countryCode: "",
				countryName: "",
        regions:[]
			};
      readDataFromWeb(vObj);
      var vCheck = validateData(vObj);
      if(vCheck){
        $.ajax({
				url: "http://localhost:8080/country/create",
				type: "POST",
				contentType: "application/json; charset=UTF-8",
				data: JSON.stringify(vObj),
				success: function(res) {
					console.log(res);
          alert("tạo Country thành công");
					window.location.reload();
				},
				error: function(err){
					alert(err.responseText);
				}
			})
      }
    }
    //Hàm thực thi khi nhấn nút Add region
    function onBtnCreateRegionClick(){
      "uses strict";
      var vObj = {
				regionCode: "",
				regionName: "",
			};
      readRegionDataFromWeb(vObj);
      var vCheck = validateRegionData(vObj);
      if(vCheck){
        $.ajax({
          url: "http://localhost:8080/region/create/" + gCountryId,
          type: "POST",
          contentType: "application/json; charset=UTF-8",
          data: JSON.stringify(vObj),
          success: function(res) {
            console.log(res);
            alert("tạo Region thành công")
            window.location.reload();
          },
          error: function(err){
            console.log(err.responseText);
          }
        })
      }
    }
    //Hàm thực thi khi nhấn nút update country
    function onBtnUpdateCountryClick(){
      "use strict";
      if(gCountryId == 0) {
				alert("Hãy click chọn hàng Country cần update");
			}
			else {
				var vObj = {
				countryCode: "",
				countryName: "",
			};
      readDataFromWeb(vObj);
      var vCheck = validateData(vObj);
      if(vCheck){
          $.ajax({
            url: "http://localhost:8080/country/update/" + gCountryId,
            type: "PUT",
            contentType: "application/json; charset=UTF-8",
            data: JSON.stringify(vObj),
            success: function(res) {
              console.log(res);
              alert("update Country thành công");
              window.location.reload();
            },
            error: function(err){
              console.log(err.responseText);
				    }
			    });
        };
			}
    }
    //Hàm thực thi khi nhấn nút update region
    function onBtnUpdateRegionClick(){
      "use strict";
      if(gRegionId == 0) {
				alert("Hãy click chọn hàng Region cần update");
			}
			else {
				var vObj = {
				regionCode: "",
				regionName: "",
			  };
        readRegionDataFromWeb(vObj);
        var vCheck = validateRegionDataToUpdate(vObj);
        if(vCheck){
          $.ajax({
            url: "http://localhost:8080/region/update/" + gRegionId,
            type: "PUT",
            contentType: "application/json; charset=UTF-8",
            data: JSON.stringify(vObj),
            success: function(res) {
              console.log(res);
              alert("update Region thành công")
              window.location.reload();
            },
            error: function(err){
              console.log(err.responseText);
            }
          })
        }
      }
    }
    //Hàm thực thi khi nhấn nút Delete country
    function onBtnDeleteCountryClick(){
      "use strict";
      if(gCountryId == 0) {
				alert("Hãy click chọn hàng Country cần delete");
			}
			else if(confirm( "Bạn có muõn xóa? \n Lưu ý toàn bộ region liên kết sẽ bị xoá theo") == true){
        $.ajax({
          url: "http://localhost:8080/country/delete/" + gCountryId,
          type: "DELETE",
          dataType: "json",
          success: function(res) {
            console.log(res);
            window.location.reload();
            alert("delete Country thành công");
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }
    }
    //Hàm thực thi khi nhấn nút Delete region
    function onBtnDeleteRegionClick(){
      "use strict";
      if(gRegionId == 0) {
				alert("Hãy click chọn hàng Region cần delete");
			}
			else if(confirm( "Ban có muõn xóa?") == true){
        $.ajax({
          url: "http://localhost:8080/region/delete/" + gRegionId,
          type: "DELETE",
          dataType: "json",
          success: function(res) {
            console.log(res);
            alert("delete Region thành công");
            window.location.reload();
          },
          error: function(err){
            console.log(err.responseText);
          }
        });
      }
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm gọi API để lấy dữ liệu country theo id
    function callAjaxApiGetCountryById(paramId) {
			$.ajax({
				url: "http://localhost:8080/country/details/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadCountryDataToForm(res);
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
    //Hàm gọi API để lấy dữ liệu country theo id
    function callAjaxApiGetRegionById(paramId) {
			$.ajax({
				url: "http://localhost:8080/region/details/" + paramId,
				type: "GET",
				dataType: "json",
				success: function(res) {
					console.log(res);
					loadRegionDataToForm(res);
				},
				error: function(err){
					console.log(err.responseText);
				}
			})
		}
    //Hàm load dữ liệu country lên form
    function loadCountryDataToForm(paramRes) {
			$("#inp-country-name").val(paramRes.countryName);
			$("#inp-country-code").val(paramRes.countryCode);
    }
    //Hàm load dữ liệu region lên form
    function loadRegionDataToForm(paramRes) {
			$("#inp-region-name").val(paramRes.regionName);
			$("#inp-region-code").val(paramRes.regionCode);
    }
    //Hàm thu thập dữ liệu để add
    function readDataFromWeb(paramObj) {
      "use strict";
			paramObj.countryCode = $("#inp-country-code").val().trim();
			paramObj.countryName = $("#inp-country-name").val().trim();
		}
    //Hàm thu thập dữ liệu để add
    function readRegionDataFromWeb(paramObj){
      "use strict";
			paramObj.regionCode = $("#inp-region-code").val().trim();
			paramObj.regionName = $("#inp-region-name").val().trim();
		}
    //Hàm validate
    function validateData(paramObj){
      "use strict"
      if(paramObj.countryCode === "") {
        alert("Hãy nhập countryCode");
        return false;
      } else if(paramObj.countryName === "") {
        alert("Hãy nhập countryName");
        return false;
      } 
      return true;
    }
    //Hàm validate
    function validateRegionData(paramObj){
      "use strict"
      if(gCountryId == 0){
        alert("Hãy click chọn Country cần add Region trước");
        return false;
      } else if(paramObj.regionCode === "") {
        alert("Hãy nhập regionCode");
        return false;
      } else if(paramObj.regionName === "") {
        alert("Hãy nhập regionName");
        return false;
      } 
      return true;
    }
    //Hàm validate
    function validateRegionDataToUpdate(paramObj){
      "use strict"
      if(paramObj.regionCode === "") {
        alert("Hãy nhập regionCode");
        return false;
      } else if(paramObj.regionName === "") {
        alert("Hãy nhập regionName");
        return false;
      } 
      return true;
    }
  });
</script>
</html>
